#include <stdlib.h>
#include "defines.h"
#include "xy.h"
#include "xyz.h"
#include "mesh.h"
typedef uns char byte;
/*-----*/
void SetTitle(HWND wn,char*S){SendMessage(wn,WM_SETTEXT,0,(long)S);}
/*-----*/
void GetTitle(HWND wn,char*S,long n){SendMessage(wn,WM_GETTEXT,n,(long)S);}
/*-----*/
HWND Wn=0;
/*-----*/
mesh::mesh(){initialize();}
/*-----*/
void mesh::initialize(int j){if(j) delarrays(); setmem(this,sizeof(mesh),0);};
/*-----*/
void mesh::delarrays(){FF(fac); FF(point); FF(pts);}
/*-----*/
void far*Farmalloc(unsigned long n){void far*q=farmalloc(n);
if(!q) if(n) MessageBox(0,"I can't get enough memory","farmalloc",OUCH); return q;}
/*-----*/
void far*Farrealloc(void *p,unsigned long n,char*name){void far*q=farrealloc(p,n);
if(!q) if(n) MessageBox(0,"I can't get enough memory",name,OUCH); return q;}
/*-----*/
int mesh::setnp_(int x,int k) {if(k?x==np_:x<=np_) return 1; Point*pp=point;
void*v=FR(point,Point,np_=x,"point");
int i; if(v) if(pp!=point) for(i=0;i<nq;i++) pts[i].p=point+(pts[i].p-pp); return !!v;}
/*-----*/
int mesh::setnq_(int x,int k) {if(k?x==nq_:x<=nq_) return 1; fcinfo*qq=pts;
void*v=FR(pts,fcinfo,nq_=x,"q");
int i; if(v) if(qq!=pts) for(i=0;i<nf;i++) if(fac[i].q) fac[i].q=pts+(fac[i].q-qq); return !!v;}
/*-----*/
int mesh::setnf_  (int x,int k) {return (k?x==nf_  :x<=nf_  )?1:FR(fac  ,Face ,nf_=x,"fac")!=0;}
/*-----*/
long mesh::addpoint(xyz P){if(!setnp_(np+1)) return 0; point[np].a=P; return np++;}
/*----*/
Face*mesh::addface(int n){
if(!setnq_(nq+n) ?1: !setnf_(nf+1)) return 0;;
Face&f=fac[nf++]; f.q=pts+nq; nq+=n; f.n=n; return &f;}
/*-----*/
int countOBJ(char*file,long&NF,long&NQ,long&NP){
FILE*G=fopen(file,"rb"); long i,j,M,N; char L[128],*P[128],Eof;
if(!G) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
LOOP: for(i=0;i<127;i++) {j=L[i]=fgetc(G); Eof=feof(G); if(Eof?1:j==10?1:j==13) break;}
N=i; L[i]=0; if(Eof) goto END; for(i=0;i<N;i++) if(L[i]<0?0:L[i]<=32) L[i]=0;
while(!N?0:!L[N-1]) N--; if(!N) goto LOOP; if(L[0]) {M=1; P[0]=L;} else M=0;
for(i=1;i<N;i++) if(L[i]) if(!L[i-1]) P[M++]=&L[i]; if(M<2) goto LOOP; /* find components */
if(!stricmp(P[0],"v")) {/* vertex */ NP++; goto LOOP;}
if(!stricmp(P[0],"f")) {NF++; NQ+=M; /* face */ goto LOOP;}
goto LOOP;
END: fclose(G); return 1;}
/*-----*/
int mesh::readOBJ(char*file){long i,j,M,N,v,T,D,C=0,NF,NQ,NP;
if(!OB) {MessageBox(0,"no mesh struct","",OUCH); return 0;}
double x,y,z; char a,L[1024],*P[1024],*V,Eof=0,Z[32],*bad; Face*F; fcinfo*I;
initialize(1); NF=nf; NQ=nq; NP=np;
countOBJ(file,NF,NQ,NP);
FILE*G=fopen(file,"rb"); if(!G) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
long dnp=0;
if(!setnf_(NF) ?1: !setnq_(NQ) ?1: !setnp_(NP)) return 0;
LOOP: for(i=0;i<1023;i++) {j=L[i]=fgetc(G); Eof=Eof?1:feof(G); if(Eof?1:j==10?1:j==13) break;}
N=i; L[i]=0;
if(Eof) goto END; for(i=0;i<N;i++) if(L[i]<0?0:L[i]<=32) L[i]=0;
while(!N?0:!L[N-1]) N--; if(!N) goto LOOP; C++;
if(L[0]) {M=1; P[0]=L;} else M=0;
for(i=1;i<N;i++) if(L[i]) if(!L[i-1]) P[M++]=&L[i]; if(M<2) goto LOOP; M--; /* find components */
if(!stricmp(P[0],"v")) {bad="<3 args"; if(M<3) goto BAD; /* vertex */
	 x=atof(P[1]); y=atof(P[2]); z=atof(P[3]); addpoint(xyz(x,y,z)); goto LOOP;}
if(!stricmp(P[0],"f")) {F=addface(M); /* face */
	 if(F) for(I=F->q,i=1;i<=M;i++) {T=D=0; V=P[i]; sscanf(V,"%ld",&v);
		  for(j=0;a=V[j],a;j++) if(a=='/') break; if(a) if(!sscanf(V+=j+1,"%ld",&T)) T=0;
		  for(j=0;a=V[j],a;j++) if(a=='/') break; if(a) if(!sscanf(V+=j+1,"%ld",&D)) D=0;
		  if(v<0) v+=np+1; else v+=dnp; bad="no such vertex";  if(v<1?1:v>np) goto BAD;
		  I[i-1].p=&point[v-1];}
	 goto LOOP;}
goto LOOP;
END: fclose(G); i=1; goto EXIT;
BAD: fclose(G); sprintf(Z,"line %d is bad: %s",C,bad); for(i=0;i<N;i++) if(!L[i]) L[i]=' ';
MessageBox(0,L,Z/*file*/,OUCH); i=0;
EXIT: setnf_(nf,1); setnq_(nq,1); setnp_(np,1);
return i;}
/*-----*/
double xb,yb,xs,ys,Rb;
/*-----*/
void Line(HDC dc,xyz A,xyz B){
MoveToEx(dc,(A.x+xb)*xs,Rb-int((A.y+yb)*ys),0);
LineTo(dc,(B.x+xb)*xs,Rb-((B.y+yb)*ys));}
/*-----*/
